# ADML REST API

## References

Read  [deployment instructions](../../../../../INSTALL_ADML_HTTP.md) document to **create** *ADML HTTP* image and **run** it.

Read  [REST API](../../../../../example/diameter/launcher/resources/HELP.md) implementation to learn how to control *ADML HTTP* execution.

## Helpers

Located at directory [helpers](./helpers).

These helpers eases *pcaps* translation into *REST API* input artifacts:

### tsharkDecoder.sh

This utility disects a  *pcap* file and gets metadata and hexadecimal encoding for diameter messages found in the capture. Those files are named as `<frame number>.hex` and `<frame number>.metadata`. Also, a list of detected *Origin-Host AVPs* is dump in the file `origin-hosts`.

For example:

> ./tsharkDecoder.sh example.pcap
>

### decodeHex.sh

Use this to decode *hex* files. For example:

> ./decodeHex.sh 8.hex

This will create the corresponding diameter message representation in two formats:

- **xml**
- **json** (through diameterJsonHelper resources)



## Component Test

Go to [ct](./ct) directory and execute:

1. pip3 install -r requirements.txt
2. pytest *-or-* pytest -n <num|auto> (parallel execution)