import pytest

@pytest.mark.helpers
def test_001_save_node(saveB64Artifact, admlc):

  requestBody = { "name":"afHost.afRealm.com" }
  responseBodyRef = { "success":"true", "response":"Forced node is now 'afHost.afRealm.com'" }

  # Send POST
  response = admlc.postDict("/node", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)

  requestBody = { "name":"" }

  # Send POST
  response = admlc.postDict("/node", requestBody)

  # Verify response is ok (omit response content because it is informative and have dynamic data (timing)):
  assert response["status"] == 200
  assert response["body"]["success"] == "true"

  # Save artifact from base64 encoded string received
  saveB64Artifact(response["body"]["response"], "helpers/node")

