// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_core_internal_ModuleManager_hpp
#define anna_core_internal_ModuleManager_hpp

#include <vector>

#include <anna/core/Singleton.hpp>

namespace anna {

class ModuleManager : public Singleton <ModuleManager> {
public:
  typedef std::pair <const char*, const char*> Module;
  typedef std::vector <Module> Modules;
  typedef Modules::const_iterator const_iterator;

  void insert(const char* module, const char* revision) throw();
  const_iterator begin() const throw() { return a_modules.begin(); }
  const_iterator end() const throw() { return a_modules.end(); }

  static const char* module(const_iterator& ii) throw() { return ii->first; }
  static const char* revision(const_iterator& ii) throw() { return ii->second;; }

private:
  Modules a_modules;

  ModuleManager() {;}

  ModuleManager(const ModuleManager&);

  friend class Singleton <ModuleManager>;
};

}

#endif

