// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_comm_TimerManager_hpp
#define anna_diameter_comm_TimerManager_hpp

#include <anna/config/defines.hpp>
#include <anna/core/util/Recycler.hpp>
#include <anna/core/Singleton.hpp>
#include <anna/timex/TimeEventObserver.hpp>
#include <anna/core/RuntimeException.hpp>

// Local
#include <anna/diameter.comm/Timer.hpp>


namespace anna {
class Millisecond;

namespace timex {
class Engine;
}
}

namespace anna {

namespace diameter {

namespace comm {


class Session;
class Response;
class LocalServer;


/**
   Timer Manager for Diameter Requests and client-session events
*/
class TimerManager : public anna::timex::TimeEventObserver, public anna::Singleton <TimerManager> {
  typedef anna::Recycler <anna::diameter::comm::Timer> timer_container;

  timer_container a_timers;
  anna::timex::Engine* a_timeController;

  TimerManager();
  TimerManager(const TimerManager&);
  virtual ~TimerManager() {;}

  Timer* createTimer(Response*) throw(anna::RuntimeException);
  Timer* createTimer(Session*, const anna::diameter::comm::Timer::Type::_v type) throw(anna::RuntimeException);
  Timer* createTimer(LocalServer*) throw(anna::RuntimeException);

  void cancelTimer(Timer*) throw();

  void release(anna::timex::TimeEvent*) throw();

  friend class anna::Singleton <TimerManager>;
  friend class Response;
  friend class Session;
  friend class LocalServer;
};

}
}
}

#endif

