// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_helpers_radius_defines_hpp
#define anna_diameter_helpers_radius_defines_hpp


// Local
#include <anna/diameter/helpers/defines.hpp>

// STL
#include <string>


/** Contextualized definitions (avp id) */
#define anna_diameter_helpers_define_avp(avpname,code)  anna_diameter_helpers_define_avp_in_context(avpname,code,radius)

/** Contextualized definitions (avp id and values) */
#define anna_diameter_helpers_define_avp_with_values(avpname,code)  anna_diameter_helpers_define_avp_with_values_in_context(avpname,code,radius)


namespace anna {

namespace diameter {

namespace helpers {

namespace radius {


/**
* Avps
*/
anna_diameter_helpers_define_avp_with_values(User_Name, 1);
anna_diameter_helpers_define_avp_with_values(Framed_IP_Address, 8);
anna_diameter_helpers_define_avp_with_values(Filter_Id, 11);
anna_diameter_helpers_define_avp_with_values(Class, 25);
anna_diameter_helpers_define_avp_with_values(Session_Timeout, 27);
anna_diameter_helpers_define_avp_with_values(Called_Station_Id, 30);
anna_diameter_helpers_define_avp_with_values(Proxy_State, 33);
anna_diameter_helpers_define_avp_with_values(Accounting_Session_Id, 44);
anna_diameter_helpers_define_avp_with_values(Acct_Multi_Session_Id, 50);
anna_diameter_helpers_define_avp_with_values(Event_Timestamp, 55);
anna_diameter_helpers_define_avp_with_values(Acct_Interim_Interval, 85);
anna_diameter_helpers_define_avp_with_values(Framed_IPv6_Prefix, 97);


/**
* Commands
*/


}
}
}
}


#undef anna_diameter_helpers_define_avp
#undef anna_diameter_helpers_define_avp_with_values

#endif
