// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <time.h>
#include <sys/time.h>
#include <stdlib.h>

#include <anna/core/util/Microsecond.hpp>
#include <anna/core/util/Millisecond.hpp>
#include <anna/core/util/Second.hpp>
#include <anna/core/functions.hpp>

using namespace std;
using namespace anna;

#define implement_operator(op) \
   bool Microsecond::operator op (const Millisecond& other) const \
      throw ()\
   {\
      return a_value op (((type_t) other.a_value) * 1000);\
   }\
   bool Microsecond::operator op (const Second& other) const\
      throw ()\
   {\
      return a_value op ((type_t) other.a_value * 1000000);\
   }

Microsecond::Microsecond(const Millisecond& other) : a_value(other.a_value) { a_value *= (type_t)1000; }

Microsecond::Microsecond(const Second& other) : a_value(other.a_value) { a_value *= (type_t)1000000; }

Microsecond& Microsecond::operator= (const Millisecond & other)
throw() {
  a_value = other.a_value;
  a_value *= (type_t)1000;
  return *this;
}

Microsecond& Microsecond::operator= (const Second & other)
throw() {
  a_value = other.a_value;
  a_value *= (type_t)1000000;
  return *this;
}

implement_operator( ==)
implement_operator( !=)
implement_operator( >)
implement_operator( <)


//static
Microsecond Microsecond::getTime()
throw() {
  struct timeval tv;
  gettimeofday(&tv, NULL);
  Microsecond result(Second(tv.tv_sec));
  result.a_value += tv.tv_usec;
  return result;
}

string Microsecond::asString() const
throw() {
  string result(functions::asString(a_value));
  return result += " us";
}

//static
Microsecond Microsecond::fromString(const std::string& value)
throw(RuntimeException) {
  if(value.find(" us") == string::npos) {
    string msg("String: ");
    msg += value;
    msg += " | Invalid expression for Microsecond";
    throw RuntimeException(msg, ANNA_FILE_LOCATION);
  }

  return Microsecond(atoll(value.c_str()));
}
