// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Local
#include <anna/diameter/codec/basetypes/Integer64.hpp>


//------------------------------------------------------------------------------
//------------------------------------------------------- Integer64::codeBasic()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Integer64::codeBasic(char* buffer, int &size) throw(anna::RuntimeException) {
  buffer[0] = (char)(a_value >> 56);
  buffer[1] = (char)(a_value >> 48);
  buffer[2] = (char)(a_value >> 40);
  buffer[3] = (char)(a_value >> 32);
  buffer[4] = (char)(a_value >> 24);
  buffer[5] = (char)(a_value >> 16);
  buffer[6] = (char)(a_value >> 8);
  buffer[7] = (char)a_value;
  size = getSize();
}


//------------------------------------------------------------------------------
//---------------------------------------------- Integer64::setPrintableString()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Integer64::setPrintableString(const char * printableString) throw(anna::RuntimeException) {
  setValue(atoll(printableString));
}


//------------------------------------------------------------------------------
//---------------------------------------------------------- Integer64::decode()
//------------------------------------------------------------------------------
void anna::diameter::codec::basetypes::Integer64::decode(const char* buffer, const int size) throw(anna::RuntimeException) {
  if(!buffer)
    throw anna::RuntimeException("Integer64::decode | Null Buffer provided", ANNA_FILE_LOCATION);

  if(size != 8)
    throw anna::RuntimeException("Integer64::decode | Buffer length must be 8 bytes", ANNA_FILE_LOCATION);

  a_value = (((S64)buffer[0] << 56) & 0xFF00000000000000LL) +    // LL es para compatibilizar con linux gcc 3.3.2
            (((S64)buffer[1] << 48) & 0x00FF000000000000LL) +
            (((S64)buffer[2] << 40) & 0x0000FF0000000000LL) +
            (((S64)buffer[3] << 32) & 0x000000FF00000000LL) +
            (((S64)buffer[4] << 24) & 0x00000000FF000000LL) +
            (((S64)buffer[5] << 16) & 0x0000000000FF0000LL) +
            (((S64)buffer[6] << 8)  & 0x000000000000FF00LL) +
            ((S64)buffer[7]         & 0x00000000000000FFLL);
}

