// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <string.h>
#include <stdlib.h>

#include <anna/config/defines.hpp>
#include <anna/core/functions.hpp>
#include <anna/core/tracing/Logger.hpp>

#include <anna/http/internal/EncodedBlock.hpp>

using namespace std;
using namespace anna;

/*
 * Esta clase va guardando los trozos del mensaje que recibe, hasta que llega el momento
 * en que considera que el Bloque est comnpleto, y entonces lo pasa al bloque principal.
 */
http::EncodedBlock::State::_v http::EncodedBlock::append(const DataBlock& chunk)
throw() {
  const int left = a_expectedSize - a_chunk.getSize();
  State::_v result(State::Incomplete);

  if(left >= chunk.getSize()) {
    a_chunk += chunk;
  } else if(left > 0) {
    DataBlock tmp(chunk.getData(), left, false);
    a_chunk += tmp;
  }

  if(a_chunk.getSize() == a_expectedSize) {
    LOGDEBUG(
      string msg("http::EncodedBlock | ");
      msg += anna::functions::asString(chunk, 24);
      Logger::debug(msg, ANNA_FILE_LOCATION);
    );
    *this += a_chunk;
    a_chunk.clear();
    a_expectedSize = -1;
    result = State::Completed;
  }

  return result;
}
